﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace adattarhazak
{
    class Program
    {
        static List<int[]> adatok = new List<int[]>();
        //static List<double> Ro = new List<double>();
        static List<double[]> Ro = new List<double[]>();
        static List<int> reszter = new List<int>();
        static List<List<int>> Zq = new List<List<int>>();
        static int müMin = 3;//300;
        static double roMin = 0.6d;//0.7d;
        static double Cmin = 0.8d;
        static List<List<double>> reprezentantIndexes = new List<List<double>>();
        static void Main(string[] args)
        {
            //Adatok beolvasása
            Beolvas();

            //Hasonlosági tér

            //Hasonlítgatás
            Hasonlit();
            //Hasonlitgatas kiirasa fajlba
            HasonlitKiir();
            //Minimáis hasonlósági osztályméretnek megfelelő objektumok meghatározása
            MinHasOsztMeretMeghat();
            //Reprezentáns objektumok sorszámának megjelenítése
            ReprezentansMegjelenit();
            //Minősített lefedő résztér meghatározása
            MinLefedoReszterMeghat();

            //Attribútum - redukció
            
            //Attribútum - minősítő tábla

            Console.ReadKey();
        }

        private static void MinLefedoReszterMeghat()
        {
            for (int i = 0; i < reprezentantIndexes.Count; i++)
            {
                for (int j = 1; j < reprezentantIndexes[i].Count; j++)
                {
                    reszter.Add((int)reprezentantIndexes[i][j]);
                }
            }
            reszter = reszter.Distinct().ToList<int>();
            reszter = reszter.OrderBy(x => x).ToList<int>();
            

            //Résztér kiírása
            foreach (var item in reszter)
            {
                Console.Write("{0}, ", item);
            }
            Console.WriteLine();
            
            //Lefedettség meghatározása
            double lefedettseg = (double)reszter.Count / adatok.Count;
            Console.WriteLine("\nA hasonlósági lefedettség:\nC = {0}/{1} = {2:0.##}", reszter.Count, adatok.Count, lefedettseg);
            Console.WriteLine("\nMivel a lefedettség ({0:0.##}) " + (lefedettseg>Cmin?"nagyobb az elvártnál ({1}), az osztályozást elfogadjuk.":"kisebb az elvárnátnál ({1}) az osztályozást nem fogadjuk el."),lefedettseg, Cmin);
        }

        private static void ReprezentansMegjelenit()
        {
            Console.WriteLine("A reprezentáns elemek indexei kiírásra kerültek (0 based index).");
            using (FileStream file = File.OpenWrite("reprezentants.txt"))
            using (StreamWriter sw = new StreamWriter(file))
            {
                foreach (var row in reprezentantIndexes)
                {
                    foreach (var item in row)
                    {
                        sw.Write("{0}; ", item);
                    }
                    sw.WriteLine();
                }
            }
        }

        private static void MinHasOsztMeretMeghat()
        {
            int count = 0;
            List<double> lista;
            for (int i = 0; i < Ro.Count; i++)
            {
                count = 0;
                lista = new List<double>();
                lista.Add(i);
                for (int j = 0; j < Ro[i].Length; j++)
                {
                    if (Ro[i][j]>roMin)
                    {
                        count++;
                        lista.Add(j);
                    }
                }
                if (count>müMin)
                {
                    reprezentantIndexes.Add(lista);
                }
            }
        }

        private static void Hasonlit()
        {
            double minSum, maxSum;
            double[] row;
            for (int i = 0; i < adatok.Count; i++)
            {
                row = new double[1000];
                for (int j = 0; j < adatok.Count; j++)
                {
                    minSum = maxSum = 0;
                    for (int k = 0; k < adatok[i].Length; k++)
                    {
                        minSum += Math.Min(adatok[i][k], adatok[j][k]);
                        maxSum += Math.Max(adatok[i][k], adatok[j][k]);
                    }
                    //Ro.Add(maxSum == 0 ? 0 : minSum / maxSum);
                    row[j] = maxSum == 0 ? 0 : minSum / maxSum;
                }
                Ro.Add(row);
            }
            Console.WriteLine("\nA hasonlítás sikeres volt.");
        }

        private static void HasonlitKiir()
        {
            using (FileStream file = File.Create("hasonlosagiTer.txt"))
            using (StreamWriter sw = new StreamWriter(file))
            {
                //for (int i = 0; i < Ro.Count; i++)
                //{
                //    if (i % adatok.Count == 0)
                //    {
                //        sw.WriteLine();
                //    }
                //    sw.Write("{0};",Ro[i].ToString());
                //}
                foreach (var item in Ro)
                {
                    foreach (var itema in item)
                    {
                        sw.Write("{0};", itema);
                    }
                    sw.WriteLine();
                }
            }
            Console.WriteLine("A hasonlítás kiírása fájlba sikeres volt.");
        }

        static void Beolvas()
        {
            string row = "";
            int[] vector = new int[5];
            int i;
            using (FileStream file = File.Open("adatok.csv",FileMode.Open))
            using (StreamReader sr = new StreamReader(file))
            {
                while (!sr.EndOfStream)
                {
                    row = sr.ReadLine();
                    vector = new int[5];
                    i = 0;
                    foreach (var item in row.Split(';'))
                    {
                        vector[i] = int.Parse(item);
                        i++;
                    }
                    adatok.Add(vector);
                }
                //foreach (var item in adatok)
                //{
                //    foreach (var itemm in item)
                //    {
                //        Console.Write(itemm + " ");
                //    }
                //    Console.WriteLine();
                //}
            }
            Console.WriteLine("\nA beolvasas sikeres volt.");
        }
    }
}
